<?php
// $Id: wizard.inc,v 1.1 2006/07/26 14:14:34 eaton Exp $

function drupal_get_wizard($wizard_id, &$wizard) {
  global $form_values, $form_submitted, $user, $form_button_counter;
  static $saved_globals = array();
  _prep_wizard($wizard);

  if ((!empty($_POST['edit'])) && ($wizard_id == $_POST['edit']['wizard_id'])) {
    array_push($saved_globals, array($form_values, $form_submitted, $form_button_counter));

    $form_values = array();
    $form_submitted = FALSE;
    $form_button_counter = array(0, 0);

    $wizard_step = $_POST['edit']['wizard_step'];
    $form_id = $_POST['edit']['form_id'];
    $wizard_build_data = $_SESSION[$wizard_id];

    if (($wizard['steps'][$wizard_step]['can_exit']) && ($_POST['op'] == $wizard['steps'][$wizard_step]['exit_button_title'])) {
      // bail out of the wizard
      $function = $wizard['exit_callback'];
      $function();
    }

    $form = wizard_build_form($wizard_id, $wizard, $wizard_step, $wizard_build_data);
    $form = drupal_build_form($form_id, $form);

    drupal_validate_form($form_id, $form);
    if (($form_submitted || (!$form_button_counter[0] && $form_button_counter[1])) && !form_get_errors()) {
      drupal_submit_form($form_id, $form);

      $wizard_step++;
      if (isset($wizard['steps'][$wizard_step])) {
        $form = wizard_build_form($wizard_id, $wizard, $wizard_step, $_POST['edit']);
        $form = drupal_build_form($wizard['steps'][$wizard_step]['form_id'], $form);
      }
      else {
        drupal_goto('node');
      }
    }

    list($form_values, $form_submitted, $form_button_counter) = array_pop($saved_globals);
  }
  else {
    $wizard_step = 0;
    $form_id = $wizard['steps'][$wizard_step]['form_id'];
    $form = wizard_build_form($wizard_id, $wizard, $wizard_step);
    $form = drupal_build_form($form_id, $form);
  }

  drupal_set_title($wizard['steps'][$wizard_step]['title']);
  $output = drupal_render_form($form_id, $form, $callback);
  return $output;
}


function wizard_build_form($wizard_id, $wizard, $step = 0, $form_values = array()) {
  $function = $wizard['steps'][$step]['form_callback'];
  $form_id = $wizard['steps'][$step]['form_id'];

  $form = $function($form_values);

  $form['#redirect'] = FALSE;

  $form['wizard_id'] = array(
    '#type' => 'hidden',
    '#value' => $wizard_id,
  );

  $form['wizard_step'] = array(
    '#type' => 'hidden',
    '#value' => $step,
  );

  if (($step + 1) < count($wizard['steps'])) {
    if ($wizard['steps'][$step]['can_exit']) {
      $form['wizard_exit'] = array(
        '#type' => 'submit',
        '#value' => $wizard['steps'][$step]['exit_button_title'],
      );
    }
  
    $form['wizard_submit'] = array(
      '#type' => 'submit',
      '#value' => $wizard['steps'][$step]['submit_button_title'],
    );
  }

  if (isset($form_values)) {
    $_SESSION[$wizard_id] = $form_values;
  }
  
  return $form;
}

function _prep_wizard(&$wizard) {
  foreach ($wizard['steps'] as $key => $step) {
    // go through all the required properties. Set 'em if they're not set.
    if (!isset($step['can_exit'])) {
      $step['can_exit'] = FALSE;
    }
    elseif (!isset($step['exit_button_title'])) {
      $step['exit_button_title'] = t('Exit wizard');
    }

    if (!isset($step['submit_button_title'])) {
      $step['submit_button_title'] = t('Submit');
    }
    if (!isset($step['exit_callback'])) {
      $step['exit_callback'] = $wizard['exit_callback'];
    }
    
    $wizard['steps'][$key] = $step;
  }
}